Index: /pjproject/branches/projects/uwp/pjlib/src/pj/sock_uwp.h
===================================================================
--- /pjproject/branches/projects/uwp/pjlib/src/pj/sock_uwp.h	(revision 5254)
+++ /pjproject/branches/projects/uwp/pjlib/src/pj/sock_uwp.h	(revision 5254)
@@ -0,0 +1,238 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2016 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#pragma once
+
+enum {
+    READ_TIMEOUT	= 60 * 1000,
+    WRITE_TIMEOUT	= 60 * 1000,
+    SEND_BUFFER_SIZE	= 128 * 1024,
+};
+
+enum PjUwpSocketType {
+    SOCKTYPE_UNKNOWN, SOCKTYPE_LISTENER,
+    SOCKTYPE_STREAM, SOCKTYPE_DATAGRAM
+};
+
+enum PjUwpSocketState {
+    SOCKSTATE_NULL, SOCKSTATE_INITIALIZED, SOCKSTATE_CONNECTING,
+    SOCKSTATE_CONNECTED, SOCKSTATE_DISCONNECTED, SOCKSTATE_ERROR
+};
+
+ref class PjUwpSocketDatagramRecvHelper;
+ref class PjUwpSocketListenerHelper;
+
+/*
+ * UWP Socket Wrapper.
+ */
+class PjUwpSocket
+{
+public:
+    PjUwpSocket(int af_, int type_, int proto_);
+    PjUwpSocket* CreateAcceptSocket(Windows::Networking::Sockets::StreamSocket^ stream_sock_);
+    virtual ~PjUwpSocket();
+
+    pj_status_t InitSocket(enum PjUwpSocketType sock_type_);
+
+public:
+    int af;
+    int type;
+    int proto;
+    pj_sockaddr local_addr;
+    pj_sockaddr remote_addr;
+    pj_bool_t is_blocking;
+    void *user_data;
+
+    enum PjUwpSocketType sock_type;
+    enum PjUwpSocketState sock_state;
+    Windows::Networking::Sockets::DatagramSocket^ datagram_sock;
+    Windows::Networking::Sockets::StreamSocket^ stream_sock;
+    Windows::Networking::Sockets::StreamSocketListener^ listener_sock;
+    
+    /* Helper objects */
+    PjUwpSocketDatagramRecvHelper^ datagram_recv_helper;
+    PjUwpSocketListenerHelper^ listener_helper;
+
+    Windows::Storage::Streams::DataReader^ socket_reader;
+    Windows::Storage::Streams::DataWriter^ socket_writer;
+    Windows::Storage::Streams::IBuffer^ send_buffer;
+    pj_bool_t is_busy_sending;
+
+    void *read_userdata;
+    void *write_userdata;
+    void *accept_userdata;
+
+    void (*on_read)(PjUwpSocket *s, int bytes_read);
+    void (*on_write)(PjUwpSocket *s, int bytes_sent);
+    void (*on_accept)(PjUwpSocket *s, pj_status_t status);
+    void (*on_connect)(PjUwpSocket *s, pj_status_t status);
+};
+
+
+//////////////////////////////////
+// Misc
+
+
+inline pj_status_t wstr_addr_to_sockaddr(const wchar_t *waddr,
+					 const wchar_t *wport,
+					 pj_sockaddr_t *sockaddr)
+{
+    char tmp_str_buf[PJ_INET6_ADDRSTRLEN+1];
+    pj_assert(wcslen(waddr) < sizeof(tmp_str_buf));
+    pj_unicode_to_ansi(waddr, wcslen(waddr), tmp_str_buf, sizeof(tmp_str_buf));
+    pj_str_t remote_host;
+    pj_strset(&remote_host, tmp_str_buf, pj_ansi_strlen(tmp_str_buf));
+    pj_sockaddr_parse(pj_AF_UNSPEC(), 0, &remote_host, (pj_sockaddr*)sockaddr);
+    pj_sockaddr_set_port((pj_sockaddr*)sockaddr,  (pj_uint16_t)_wtoi(wport));
+
+    return PJ_SUCCESS;
+}
+
+
+inline pj_status_t sockaddr_to_hostname_port(const pj_sockaddr_t *sockaddr,
+					     Windows::Networking::HostName ^&hostname,
+					     int *port)
+{
+    char tmp[PJ_INET6_ADDRSTRLEN];
+    wchar_t wtmp[PJ_INET6_ADDRSTRLEN];
+    pj_sockaddr_print(sockaddr, tmp, PJ_INET6_ADDRSTRLEN, 0);
+    pj_ansi_to_unicode(tmp, pj_ansi_strlen(tmp), wtmp,
+	PJ_INET6_ADDRSTRLEN);
+    hostname = ref new Windows::Networking::HostName(ref new Platform::String(wtmp));
+    *port = pj_sockaddr_get_port(sockaddr);
+
+    return PJ_SUCCESS;
+}
+
+
+/* Buffer helper */
+
+#include <Robuffer.h>
+#include <wrl/client.h>
+
+inline Microsoft::WRL::ComPtr<Windows::Storage::Streams::IBufferByteAccess> GetBufferByteAccess(Windows::Storage::Streams::IBuffer^ buffer)
+{
+    auto pUnk = reinterpret_cast<IUnknown*>(buffer);
+
+    Microsoft::WRL::ComPtr<Windows::Storage::Streams::IBufferByteAccess> comBuff;
+    pUnk->QueryInterface(__uuidof(Windows::Storage::Streams::IBufferByteAccess), (void**)comBuff.ReleaseAndGetAddressOf());
+
+    return comBuff;
+}
+
+
+inline void GetRawBufferFromIBuffer(Windows::Storage::Streams::IBuffer^ buffer, unsigned char** pbuffer)
+{
+    Platform::Object^ obj = buffer;
+    Microsoft::WRL::ComPtr<IInspectable> insp(reinterpret_cast<IInspectable*>(obj));
+    Microsoft::WRL::ComPtr<Windows::Storage::Streams::IBufferByteAccess> bufferByteAccess;
+    insp.As(&bufferByteAccess);
+    bufferByteAccess->Buffer(pbuffer);
+}
+
+inline void CopyToIBuffer(unsigned char* buffSource, unsigned int copyByteCount, Windows::Storage::Streams::IBuffer^ buffer, unsigned int writeStartPos = 0)
+{
+    auto bufferLen = buffer->Capacity;
+    assert(copyByteCount <= bufferLen);
+
+    unsigned char* pBuffer;
+
+    GetRawBufferFromIBuffer(buffer, &pBuffer);
+
+    memcpy(pBuffer + writeStartPos, buffSource, copyByteCount);
+}
+
+inline void CopyFromIBuffer(unsigned char* buffDestination, unsigned int copyByteCount, Windows::Storage::Streams::IBuffer^ buffer, unsigned int readStartPos = 0)
+{
+    assert(copyByteCount <= buffer->Capacity);
+
+    unsigned char* pBuffer;
+
+    GetRawBufferFromIBuffer(buffer, &pBuffer);
+
+    memcpy(buffDestination, pBuffer + readStartPos, copyByteCount);
+}
+
+
+/* PPL helper */
+
+#include <ppltasks.h>
+#include <agents.h>
+
+// Creates a task that completes after the specified delay, in ms.
+inline concurrency::task<void> complete_after(unsigned int timeout)
+{
+    // A task completion event that is set when a timer fires.
+    concurrency::task_completion_event<void> tce;
+
+    // Create a non-repeating timer.
+    auto fire_once = new concurrency::timer<int>(timeout, 0, nullptr, false);
+    // Create a call object that sets the completion event after the timer fires.
+    auto callback = new concurrency::call<int>([tce](int)
+    {
+	tce.set();
+    });
+
+    // Connect the timer to the callback and start the timer.
+    fire_once->link_target(callback);
+    fire_once->start();
+
+    // Create a task that completes after the completion event is set.
+    concurrency::task<void> event_set(tce);
+
+    // Create a continuation task that cleans up resources and 
+    // and return that continuation task. 
+    return event_set.then([callback, fire_once]()
+    {
+	delete callback;
+	delete fire_once;
+    });
+}
+
+// Cancels the provided task after the specifed delay, if the task 
+// did not complete. 
+template<typename T>
+inline concurrency::task<T> cancel_after_timeout(concurrency::task<T> t, concurrency::cancellation_token_source cts, unsigned int timeout)
+{
+    // Create a task that returns true after the specified task completes.
+    concurrency::task<bool> success_task = t.then([](T)
+    {
+	return true;
+    });
+    // Create a task that returns false after the specified timeout.
+    concurrency::task<bool> failure_task = complete_after(timeout).then([]
+    {
+	return false;
+    });
+
+    // Create a continuation task that cancels the overall task  
+    // if the timeout task finishes first. 
+    return (failure_task || success_task).then([t, cts](bool success)
+    {
+	if (!success)
+	{
+	    // Set the cancellation token. The task that is passed as the 
+	    // t parameter should respond to the cancellation and stop 
+	    // as soon as it can.
+	    cts.cancel();
+	}
+
+	// Return the original task. 
+	return t;
+    });
+}
Index: /pjproject/branches/projects/uwp/pjmedia/src/pjmedia-audiodev/wasapi_dev.cpp
===================================================================
--- /pjproject/branches/projects/uwp/pjmedia/src/pjmedia-audiodev/wasapi_dev.cpp	(revision 5253)
+++ /pjproject/branches/projects/uwp/pjmedia/src/pjmedia-audiodev/wasapi_dev.cpp	(revision 5254)
@@ -27,4 +27,5 @@
 #include <windows.h>
 #include <audioclient.h>
+#include <Processthreadsapi.h>
 
 #if defined(PJ_WIN32_UWP) && PJ_WIN32_UWP
@@ -38,5 +39,5 @@
     using namespace Windows::Media::Devices;  
     using namespace Microsoft::WRL;
-    using namespace concurrency;
+    using namespace concurrency;   
 #else
     #include <phoneaudioclient.h>
@@ -107,6 +108,5 @@
     unsigned		    bytes_per_sample;
 
-    /* Playback */
-    LPCWSTR		    pb_id;		/* playback Id		    */
+    /* Playback */    
     pjmedia_aud_play_cb	    pb_cb;		/* Playback callback	    */
     IAudioClient2	   *default_pb_dev;     /* Default playback dev	    */
@@ -118,8 +118,10 @@
 #if defined(USE_ASYNC_ACTIVATE)
     ComPtr<AudioActivator>  pb_aud_act;
-#endif
-
-    /* Capture */
-    LPCWSTR		    cap_id;		/* Capture Id		    */	
+    Platform::String^	    pb_id;
+#else
+    LPCWSTR		    pb_id;		
+#endif
+
+    /* Capture */    
     pjmedia_aud_rec_cb	    cap_cb;		/* Capture callback	    */
     IAudioClient2	   *default_cap_dev;	/* Default capture dev	    */    
@@ -133,4 +135,7 @@
 #if defined(USE_ASYNC_ACTIVATE)
     ComPtr<AudioActivator>  cap_aud_act;
+    Platform::String^	    cap_id;
+#else
+    LPCWSTR		    cap_id;		
 #endif
 };
@@ -251,23 +256,4 @@
 	events[eventCount++] = strm->cap_event;
 
-    /* Raise self priority. We don't want the audio to be distorted by
-     * system activity.
-     */
-#if defined(PJ_WIN32_WINCE) && PJ_WIN32_WINCE != 0
-    if (strm->param.dir & PJMEDIA_DIR_PLAYBACK)
-	CeSetThreadPriority(GetCurrentThread(), 153);
-    else
-	CeSetThreadPriority(GetCurrentThread(), 247);
-#else
-    //SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_TIME_CRITICAL);
-#endif
-
-    /* Raise thread priority */
-    //   mmcs_handle = AvSetMmThreadCharacteristicsW(L"Audio", 
-    //						     &mmcss_task_index);
-    //   if (!mmcs_handle) {
-    //PJ_LOG(4,(THIS_FILE, "Unable to enable MMCS on wasapi stream thread"));
-    //   }
-
     /*
      * Loop while not signalled to quit, wait for event objects to be 
@@ -336,4 +322,5 @@
 	    hr = strm->pb_client->GetBuffer(frame_to_render, &cur_pb_buf);
 	    if (FAILED(hr)) {
+		PJ_LOG(4, (THIS_FILE, "Error getting wasapi buffer"));
 		continue;
 	    }
@@ -353,4 +340,5 @@
 	    hr = strm->pb_client->ReleaseBuffer(frame_to_render, 0);
 	    if (FAILED(hr)) {
+		PJ_LOG(4, (THIS_FILE, "Error releasing wasapi buffer"));
 		continue;
 	    }
@@ -363,6 +351,8 @@
 
 	    hr = strm->cap_client->GetNextPacketSize(&packet_size);
-	    if (FAILED(hr))
+	    if (FAILED(hr)) {
+		PJ_LOG(4, (THIS_FILE, "Error getting next packet size"));
 		continue;
+	    }
 	    
 	    while (packet_size) {
@@ -380,4 +370,6 @@
 
 		if (FAILED(hr) || (next_frame_size == 0)) {
+		    PJ_LOG(4, (THIS_FILE, "Error getting next buffer, \
+			       next frame size : %d", next_frame_size));
 		    packet_size = 0;
 		    continue;
@@ -480,11 +472,11 @@
 
 		hr = strm->cap_client->GetNextPacketSize(&packet_size);
-		if (FAILED(hr))
+		if (FAILED(hr)) {
+		    PJ_LOG(4, (THIS_FILE, "Error getting next packet size"));
 		    packet_size = 0;
+		}
 	    }
 	}
     }
-
-    //AvRevertMmThreadCharacteristics(mmcs_handle);
 
     PJ_LOG(5,(THIS_FILE, "WASAPI: thread stopping.."));
@@ -499,5 +491,5 @@
     ComPtr<IActivateAudioInterfaceAsyncOperation> async_op;
     ws->cap_id = MediaDevice::GetDefaultAudioCaptureId(
-				      AudioDeviceRole::Communications)->Data();
+					      AudioDeviceRole::Communications);
 #else
     ws->cap_id = GetDefaultAudioCaptureId(AudioDeviceRole::Communications);
@@ -510,4 +502,5 @@
 
 #if defined(USE_ASYNC_ACTIVATE)
+
     ws->cap_aud_act = Make<AudioActivator>();
     if (ws->cap_aud_act == NULL) {
@@ -515,10 +508,12 @@
 	return PJMEDIA_EAUD_SYSERR;
     }
-    hr = ActivateAudioInterfaceAsync(ws->cap_id, __uuidof(IAudioClient2), 
+    hr = ActivateAudioInterfaceAsync(ws->cap_id->Data(), 
+				     __uuidof(IAudioClient2), 
 				     NULL, ws->cap_aud_act.Get(), 
 				     &async_op);
 
+    //pj_thread_sleep(100);
     auto task_completed = create_task(ws->cap_aud_act->task_completed);
-    task_completed.wait();
+    task_completed.wait();    
     ws->default_cap_dev = task_completed.get().Get();
 #else
@@ -526,4 +521,12 @@
 				(void**)&ws->default_cap_dev);
 #endif
+    AudioClientProperties properties = {};
+    if (SUCCEEDED(hr))
+    {
+	properties.cbSize = sizeof AudioClientProperties;
+	properties.eCategory = AudioCategory_Communications;
+	hr = ws->default_cap_dev->SetClientProperties(&properties);
+    }
+
     return FAILED(hr) ? PJMEDIA_EAUD_SYSERR : PJ_SUCCESS;
 }
@@ -634,5 +637,5 @@
 
     ws->pb_id = MediaDevice::GetDefaultAudioRenderId(
-				      AudioDeviceRole::Communications)->Data();
+					      AudioDeviceRole::Communications);
 #else
     ws->pb_id = GetDefaultAudioRenderId(AudioDeviceRole::Communications);
@@ -650,8 +653,10 @@
 	return PJMEDIA_EAUD_SYSERR;
     }
-    hr = ActivateAudioInterfaceAsync(ws->pb_id, __uuidof(IAudioClient2),
+    hr = ActivateAudioInterfaceAsync(ws->pb_id->Data(), 
+				     __uuidof(IAudioClient2),
 				     NULL, ws->pb_aud_act.Get(),
 				     &async_op);
 
+    //pj_thread_sleep(100);
     auto task_completed = create_task(ws->pb_aud_act->task_completed);
     task_completed.wait();
@@ -661,4 +666,12 @@
 				(void**)&ws->default_pb_dev);
 #endif
+
+    AudioClientProperties properties = {};
+    if (SUCCEEDED(hr))
+    {
+	properties.cbSize = sizeof AudioClientProperties;
+	properties.eCategory = AudioCategory_Communications;
+	hr = ws->default_pb_dev->SetClientProperties(&properties);
+    }
     
     return FAILED(hr) ? PJMEDIA_EAUD_SYSERR : PJ_SUCCESS;
@@ -1025,29 +1038,4 @@
     }
 
-    /* Apply the remaining settings */
-    /* Set the output volume */
- //   if (param->flags & PJMEDIA_AUD_DEV_CAP_OUTPUT_VOLUME_SETTING) {
- //       status = wasapi_stream_set_cap(&strm->base,
- //                             PJMEDIA_AUD_DEV_CAP_OUTPUT_VOLUME_SETTING,
- //                             &param->output_vol);
-	//if (status != PJ_SUCCESS) {
-	//    PJ_LOG(4, (THIS_FILE, "Error setting output volume:%d", status));
-	//}
- //   }
-
- //   /* Set the audio routing ONLY if app explicitly asks one */
- //   if ((param->dir & PJMEDIA_DIR_PLAYBACK) &&
-	//(param->flags & PJMEDIA_AUD_DEV_CAP_OUTPUT_ROUTE))
- //   {
-	//PJ_TODO(CREATE_STREAM_WITH_AUDIO_ROUTE);
-	////status = wasapi_stream_set_cap(&strm->base,
-	////			       PJMEDIA_AUD_DEV_CAP_OUTPUT_ROUTE,
-	////			       &param->output_route);
-	////if (status != PJ_SUCCESS) {
-	////    PJ_LOG(4, (THIS_FILE, "Error setting output route,status: %d",
-	////	       status));
-	////}
- //   } 
-
     strm->quit_event = CreateEventEx(NULL, NULL, CREATE_EVENT_MANUAL_RESET, 
 				     EVENT_ALL_ACCESS);
@@ -1127,39 +1115,4 @@
 
     PJ_ASSERT_RETURN(s && pval, PJ_EINVAL);
-
-
- //   if (cap==PJMEDIA_AUD_DEV_CAP_OUTPUT_ROUTE &&
- //       (strm->param.dir & PJMEDIA_DIR_PLAYBACK))
- //   {
-	//pjmedia_aud_dev_route route;
-	//AudioRoutingEndpoint endpoint;
-	//AudioRoutingManager ^routing_mgr = AudioRoutingManager::GetDefault();
-
-	//PJ_ASSERT_RETURN(pval, PJ_EINVAL);
-
- //   	route = *((pjmedia_aud_dev_route*)pval);
- //       /* Use the initialization function which lazy-inits the
- //        * handle for routing
- //        */
-	//switch (route) {
-	//    case PJMEDIA_AUD_DEV_ROUTE_DEFAULT :
-	//	endpoint = AudioRoutingEndpoint::Default;
-	//	break;
-	//    case PJMEDIA_AUD_DEV_ROUTE_LOUDSPEAKER :
-	//	endpoint = AudioRoutingEndpoint::Speakerphone;
-	//	break;
-	//    case PJMEDIA_AUD_DEV_ROUTE_EARPIECE :
-	//	endpoint = AudioRoutingEndpoint::Earpiece;
-	//	break;    
-	//    case PJMEDIA_AUD_DEV_ROUTE_BLUETOOTH :
-	//	endpoint = AudioRoutingEndpoint::Bluetooth;
-	//	break;
-	//    default:
-	//	endpoint = AudioRoutingEndpoint::Default;		
-	//}
-	//routing_mgr->SetAudioEndpoint(endpoint);
-	//
-	//return PJ_SUCCESS;
- //   } 
 
     return PJMEDIA_EAUD_INVCAP;
@@ -1296,11 +1249,4 @@
     }
 
-    if (ws->cap_id) {
-	CoTaskMemFree((LPVOID)ws->cap_id);
-    }
-
-    if (ws->pb_id) {
-	CoTaskMemFree((LPVOID)ws->pb_id);
-    }
 
 #if defined(USE_ASYNC_ACTIVATE)
@@ -1312,4 +1258,20 @@
     if (ws->pb_aud_act) {
 	ws->pb_aud_act = nullptr;
+    }
+
+    if (ws->cap_id) {
+	ws->cap_id = nullptr;
+    }
+
+    if (ws->pb_id) {
+	ws->pb_id = nullptr;
+    }
+#else
+    if (ws->cap_id) {
+	CoTaskMemFree((LPVOID)ws->cap_id);
+    }
+
+    if (ws->pb_id) {
+	CoTaskMemFree((LPVOID)ws->pb_id);
     }
 #endif
Index: /pjproject/branches/projects/uwp/pjproject-vs14.sln
===================================================================
--- /pjproject/branches/projects/uwp/pjproject-vs14.sln	(revision 5253)
+++ /pjproject/branches/projects/uwp/pjproject-vs14.sln	(revision 5254)
@@ -6,4 +6,5 @@
 Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Solution Items", "Solution Items", "{1DFF1CF3-DBD7-4DA4-A36D-663D695EB678}"
 	ProjectSection(SolutionItems) = preProject
+		build\vs\pjproject-vs14-api-def.props = build\vs\pjproject-vs14-api-def.props
 		build\vs\pjproject-vs14-arm-common-defaults.props = build\vs\pjproject-vs14-arm-common-defaults.props
 		build\vs\pjproject-vs14-arm-release-defaults.props = build\vs\pjproject-vs14-arm-release-defaults.props
@@ -97,4 +98,32 @@
 EndProject
 Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "pjsua_winrt", "pjsua_winrt", "{54F6163A-66C6-4F09-844D-CC61DE8EE376}"
+EndProject
+Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "winrt sample", "winrt sample", "{78DA8BE5-2D77-49D6-8CA4-7847B65DBE84}"
+EndProject
+Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "uwp foreground", "uwp foreground", "{452C38CE-6463-4963-A113-658B6BD91D15}"
+EndProject
+Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "wp8", "wp8", "{DE5C2BE2-873A-4B85-8EBE-8AEA4C80212F}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "Agents", "pjsip-apps\src\pjsua\winrt\gui\wp8\Agents\Agents.csproj", "{820034C1-645D-4340-8813-D980C1EF77DE}"
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "BackEnd", "pjsip-apps\src\pjsua\winrt\gui\wp8\BackEnd\BackEnd.vcxproj", "{C8D75245-FFCF-4932-A228-C9CC8BB60B03}"
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "BackEndProxyStub", "pjsip-apps\src\pjsua\winrt\gui\wp8\BackEndProxyStub\BackEndProxyStub.vcxproj", "{BBABEEA1-494C-4618-96E3-399873A5558B}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "UI", "pjsip-apps\src\pjsua\winrt\gui\wp8\UI\UI.csproj", "{3085ACA0-00DA-45BF-9110-A3684B56EBBA}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "UI", "pjsip-apps\src\pjsua\winrt\gui\uwp foreground\UI\UI.csproj", "{D51DC5BE-5822-4B94-891C-E1B1B7892939}"
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "BackEnd", "pjsip-apps\src\pjsua\winrt\gui\uwp foreground\BackEnd\BackEnd.vcxproj", "{9C5609A2-32A2-483F-81EC-DAC2ED96BF6A}"
+EndProject
+Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "uwp", "uwp", "{87D83489-039E-4123-BE01-CB62EE932A29}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "Voip", "pjsip-apps\src\pjsua\winrt\gui\uwp\Voip\Voip.csproj", "{B11B5672-B1E8-4C77-BDA1-4E6620F96BF9}"
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "VoipBackEnd", "pjsip-apps\src\pjsua\winrt\gui\uwp\VoipBackEnd\VoipBackEnd.vcxproj", "{FC9CBB95-624C-4CE8-86A8-3AB5A415AA65}"
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "VoipHost", "pjsip-apps\src\pjsua\winrt\gui\uwp\VoipHost\VoipHost.vcxproj", "{016D497F-0EE0-449E-89F5-BD63F7F9A8A6}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "VoipTasks", "pjsip-apps\src\pjsua\winrt\gui\uwp\VoipTasks\VoipTasks.csproj", "{9FDF5E33-D15D-409F-876E-4E77727936B9}"
 EndProject
 Global
